package cn.com.infosec.asn1;

import java.io.ByteArrayInputStream;
import java.io.EOFException;
import java.io.FilterInputStream;
import java.io.IOException;
import java.io.InputStream;

/** @deprecated */
public class DERInputStream extends FilterInputStream implements DERTags {
   /** @deprecated */
   public DERInputStream(InputStream is) {
      super(is);
   }

   protected int readLength() {
      int var1;
      if ((var1 = this.read()) >= 0) {
         if (var1 == 128) {
            return -1;
         } else {
            int var2;
            if (var1 > 127) {
               if ((var1 &= 127) > 4) {
                  throw new IOException("DER length more than 4 bytes");
               }

               var2 = 0;

               for(int var3 = 0; var3 < var1; ++var3) {
                  int var4;
                  if ((var4 = this.read()) < 0) {
                     throw new IOException("EOF found reading length");
                  }

                  var2 = (var2 << 8) + var4;
               }

               if (var2 < 0) {
                  throw new IOException("corrupted stream - negative length found");
               }
            } else {
               var2 = var1;
            }

            return var2;
         }
      } else {
         throw new IOException("EOF found when length expected");
      }
   }

   protected void readFully(byte[] bytes) {
      int var2;
      if ((var2 = bytes.length) != 0) {
         while(var2 > 0) {
            int var3;
            if ((var3 = this.read(bytes, bytes.length - var2, var2)) < 0) {
               throw new EOFException("unexpected end of stream");
            }

            var2 -= var3;
         }

      }
   }

   protected DERObject buildObject(int tag, byte[] bytes) {
      if (tag != 10) {
         if (tag != 12) {
            if (tag != 30) {
               if (tag != 19) {
                  if (tag != 20) {
                     ByteArrayInputStream var7;
                     BERInputStream tag1;
                     if (tag != 48) {
                        if (tag != 49) {
                           int var11;
                           switch (tag) {
                              case 1:
                                 return new DERBoolean(bytes);
                              case 2:
                                 return new DERInteger(bytes);
                              case 3:
                                 byte[] var10000 = bytes;
                                 var11 = bytes[0];
                                 byte[] tag2 = new byte[bytes.length - 1];
                                 int bytes1 = bytes.length - 1;
                                 System.arraycopy(var10000, 1, tag2, 0, bytes1);
                                 return new DERBitString(tag2, var11);
                              case 4:
                                 return new DEROctetString(bytes);
                              case 5:
                                 return DERNull.INSTANCE;
                              case 6:
                                 return new DERObjectIdentifier(bytes);
                              default:
                                 switch (tag) {
                                    case 22:
                                       return new DERIA5String(bytes);
                                    case 23:
                                       return new DERUTCTime(bytes);
                                    case 24:
                                       return new DERGeneralizedTime(bytes);
                                    default:
                                       switch (tag) {
                                          case 26:
                                             return new DERVisibleString(bytes);
                                          case 27:
                                             return new DERGeneralString(bytes);
                                          case 28:
                                             return new DERUniversalString(bytes);
                                          default:
                                             if ((tag & 128) != 0) {
                                                if ((var11 = tag & 31) != 31) {
                                                   if (bytes.length == 0) {
                                                      if ((tag & 32) == 0) {
                                                         DERNull tag7;
                                                         tag7 = new DERNull.<init>();
                                                         return new DERTaggedObject(false, var11, tag7);
                                                      } else {
                                                         DERConstructedSequence tag6;
                                                         tag6 = new DERConstructedSequence.<init>();
                                                         return new DERTaggedObject(false, var11, tag6);
                                                      }
                                                   } else if ((tag & 32) == 0) {
                                                      DEROctetString tag5;
                                                      tag5 = new DEROctetString.<init>(bytes);
                                                      return new DERTaggedObject(false, var11, tag5);
                                                   } else {
                                                      ByteArrayInputStream tag3;
                                                      tag3 = new ByteArrayInputStream.<init>(bytes);
                                                      BERInputStream bytes2;
                                                      BERInputStream var20 = bytes2 = new BERInputStream;
                                                      var20.<init>(tag3);
                                                      DERObject tag4 = var20.readObject();
                                                      if (var20.available() == 0) {
                                                         return new DERTaggedObject(var11, tag4);
                                                      } else {
                                                         DERConstructedSequence var3;
                                                         DERConstructedSequence var21 = var3 = new DERConstructedSequence;
                                                         var21.<init>();
                                                         var21.addObject(tag4);

                                                         try {
                                                            while(true) {
                                                               var3.addObject(bytes2.readObject());
                                                            }
                                                         } catch (EOFException var4) {
                                                            return new DERTaggedObject(false, var11, var3);
                                                         }
                                                      }
                                                   }
                                                } else {
                                                   throw new IOException("unsupported high tag encountered");
                                                }
                                             } else {
                                                return new DERUnknownTag(tag, bytes);
                                             }
                                       }
                                 }
                           }
                        } else {
                           var7 = new ByteArrayInputStream.<init>(bytes);
                           tag1 = new BERInputStream.<init>(var7);
                           ASN1EncodableVector var10;
                           var10 = new ASN1EncodableVector.<init>();

                           try {
                              while(true) {
                                 var10.add(tag1.readObject());
                              }
                           } catch (EOFException var5) {
                              return new DERConstructedSet(var10);
                           }
                        }
                     } else {
                        var7 = new ByteArrayInputStream.<init>(bytes);
                        tag1 = new BERInputStream.<init>(var7);
                        DERConstructedSequence var8;
                        var8 = new DERConstructedSequence.<init>();

                        try {
                           while(true) {
                              var8.addObject(tag1.readObject());
                           }
                        } catch (EOFException var6) {
                           return var8;
                        }
                     }
                  } else {
                     return new DERT61String(bytes);
                  }
               } else {
                  return new DERPrintableString(bytes);
               }
            } else {
               return new DERBMPString(bytes);
            }
         } else {
            return new DERUTF8String(bytes);
         }
      } else {
         return new DEREnumerated(bytes);
      }
   }

   public DERObject readObject() {
      int var1;
      if ((var1 = this.read()) != -1) {
         DERInputStream var10000 = this;
         byte[] var2;
         this.readFully(var2 = new byte[this.readLength()]);
         return var10000.buildObject(var1, var2);
      } else {
         throw new EOFException();
      }
   }
}
